﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace System.Events
{
    /// <summary>
    /// A service capable of publishing events.
    /// </summary>
    public interface IEventPublisher
    {
        //IEnumerable<Lazy<IMessageRecipient, IMessageRecipientMetadata>> AutodiscoveredRecipients { get; set; }

        /// <summary>
        /// Publishes the specified event.
        /// </summary>
        /// <typeparam name="TEvent">The type of the event.</typeparam>
        /// <param name="event">The event instance.</param>
        void Publish<TEvent>(TEvent @event);

        void Publish<TEvent>(TEvent @event, Action FinallyAction);
        Task PublishAsync<TEvent>(TEvent @event, Action FinallyAction);

        /// <summary>
        /// Gets the event for use by subscribers.
        /// </summary>
        /// <typeparam name="TEvent">The type of the event.</typeparam>
        /// <returns></returns>
        IObservable<TEvent> GetEvent<TEvent>();
    }
}
