﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace System.Runtime.Serialization
{
    public static class Extensions
    {
        // *** Methods ***

        public static object DeserializeFromArray(this byte[] data, Type type)
        {
            using (MemoryStream stream = new MemoryStream(data))
            {
                DataContractSerializer serializer = new DataContractSerializer(type);
                return serializer.ReadObject(stream);
            }
        }

        public static T DeserializeFromArray<T>(this byte[] data)
        {
            return (T)DeserializeFromArray(data, typeof(T));
        }

        public static byte[] SerializeToArray(this object value, Type type)
        {
            using (MemoryStream stream = new MemoryStream())
            {
                DataContractSerializer serializer = new DataContractSerializer(type);
                serializer.WriteObject(stream, value);
                return stream.ToArray();
            }
        }

        public static byte[] SerializeToArray<T>(this T value)
        {
            return SerializeToArray(value, typeof(T));
        }
    }
}
