﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Windows.UI.Notifications;

namespace Windows.UI.Notifications
{
    public class ToastNotificationData
    {
        public ToastNotifier Notifier { get; private set; }
        public ToastTemplateType TemplateType { get; private set; }
        public string ImageSrc { get; private set; }
        public bool LoopAudio { get; private set; }
        public string AudioSrc { get; private set; }
        public int ShowDuration { get; private set; }
        public string[] Message { get; private set; }

        public ToastNotificationData(
            ToastNotifier notifier,
            ToastTemplateType templateType = ToastTemplateType.ToastImageAndText04,
            string toastImageSrc = null,
            bool loopAudio = false,
            string AudioSrc = "ms-winsoundevent:Notification.IM",
            int showDuration = 1,
            //Action<IToastNotification> onActivated = null,
            //Action<IToastNotification, IToastDismissedEventArgs> onDismissed = null,
            //Action<IToastNotification, IToastFailedEventArgs> onFailed = null,
            params string[] message)
        {
            Notifier = notifier;
            TemplateType = templateType;
            ImageSrc = toastImageSrc;
            LoopAudio = loopAudio;
            ShowDuration = showDuration;
            //OnActivated = onActivated;
            //OnDismissed = onDismissed;
            //OnFailed = onFailed;
            Message = message;
        }
        public ToastNotificationData(string message)
            : this(null, ToastTemplateType.ToastText01)
        {
            Message = new string[] { message };
        }
    }

}
